/// <reference types="node" />
export declare enum DataTypes {
    BYTE = 0,
    BOOL = 1,
    INT8 = 2,
    INT16 = 3,
    INT32 = 4,
    UINT8 = 5,
    UINT16 = 6,
    UINT32 = 7,
    FLOAT = 8,
    DOUBLE = 9,
    DATE = 10,
    STRING = 11,
    BYTE_ARRAY = 12
}
export declare class ByteList {
    static SetBit(num: number, val: boolean, bit: number): number;
    static GetBit(num: number, bit: number): boolean;
    index: number;
    useLittleEndian: boolean;
    get length(): number;
    get paddingSize(): number;
    set paddingSize(val: number);
    private _paddingSize;
    private _length;
    private _buffer;
    constructor(bytes?: any);
    getBuffer(): Buffer;
    getLength(): number;
    concat(bytes: ArrayBuffer | Buffer | ByteList | number[]): void;
    insert(buffer: Buffer | ByteList | Uint8Array): void;
    peekByte(offset?: number): number;
    peekUInt16(offset?: number): number;
    peekUInt32(offset?: number): number;
    writeByte(byte: any, options?: any): void;
    writeInt8(int8: number, options?: any): void;
    writeBool(bool: boolean, options?: any): void;
    writeInt16(int16: number, options?: any): void;
    writeInt32(int32: number, options?: any): void;
    writeUInt16(uint16: number, options?: any): void;
    writeUInt32(uint32: number, options?: any): void;
    writeFloat(float: number, options?: any): void;
    writeDouble(double: number, options?: any): void;
    writeDate(date: Date, options?: any): void;
    writeString(str?: string, options?: {
        insert?: boolean;
        length?: number;
    }): void;
    writeByteArray(list: any, options?: any): void;
    writeData(type: DataTypes, val?: any, options?: any): void;
    trimLeft(count: number): Buffer;
    trimRight(count: number): Buffer;
    readByte(): number;
    readInt8(): number;
    readBool(): boolean;
    readInt16(): number;
    readInt32(): number;
    readUInt16(): number;
    readUInt32(): number;
    readFloat(): number;
    readDouble(): number;
    readDate(): Date | null;
    readBytes(count: number): Buffer;
    readString(options?: {
        length?: number;
    }): string;
    readByteArray(): number[];
    readData(type: DataTypes, options?: any): any;
    toString(): string;
    private prepareBuffer;
}
